#!/usr/bin/bash

# Provide a service that can perform actions upon the first appliance boot
# after install, and also after upgrades

# Where to write log
LOG="/data/log/firstbootfix.log"

exec &>> $LOG 

export CERTFILE="/opt/ECX/virgo/configuration/ecx-beta.crt"
export KEYFILE="/opt/ECX/virgo/configuration/ecx-beta.key"

date

# This will only ever be done after the initial deployment
if [ -r /etc/spp-deploy ] ; then
    echo "#### Processing initial deployment fixes"
    rm -f /etc/spp-deploy

    # # regenerate new SSH host keys
    # echo "## Remove and generate new ssh host keys"
    # rm /etc/ssh/ssh_host*
    # ssh-keygen -b 4096 -f /etc/ssh/ssh_host_rsa_key -t rsa -N ""
    # ssh-keygen -b 1024 -f /etc/ssh/ssh_host_dsa_key -t dsa -N ""
    # ssh-keygen -b 521 -f /etc/ssh/ssh_host_ecdsa_key -t ecdsa -N ""
    # ssh-keygen -b 4096 -f /etc/ssh/ssh_host_ed25519_key -t ed25519 -N ""
    # chmod 600 /etc/ssh/ssh_host_*_key

    # systemctl restart sshd

    echo "## Generate new reverse proxy SSL cert"

    /opt/ECX/tools/scripts/generate_default_cert -c $CERTFILE -k $KEYFILE

fi

# Anything from here can run when upgrades are applied
echo "#### Processing upgrade fixes"

# disable the service as it's only intended to run once after initial deploy
# or upgrade
echo "## Disabling service after first run"
systemctl disable firstbootfix.service